include:
  - local: infra/gitlab-ci/docker.yml
  - local: infra/gitlab-ci/terraform.yml
  - local: infra/gitlab-ci/helm.yml

stages:
  - lint utilities
  - build utilities
  - lint application
  - build application
  - post lint application
  - validate terraform
  - plan terraform
  - apply terraform
  - deploy application

variables:
  BRANCH_TAG: $CI_COMMIT_REF_NAME
  COMMIT_TAG: $CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA
  DOCKER_REPO: $DOCKER_REGISTRY/$PROJECT_NAME 

  TF_ROOT: $CI_PROJECT_DIR/infra/terraform

cache:
  paths:
    - $CI_PROJECT_DIR/infra/terraform
    - $CI_PROJECT_DIR/kube_config

# lint application

lint apigw dockerfile:
  stage: lint application
  extends: .lint_dockerfile
  variables:
    DOCKERFILE_CONTEXT: ./gateway
  needs: []

validate docker compose:
  stage: lint application
  image: docker/compose:alpine-1.28.0-rc1
  script:
    - docker-compose -f docker-compose.yml config
    - echo "docker compose file successfuly validated"
  needs: []

# build application

build apigw dockerfile:
  stage: build application
  extends: .build_docker
  variables:
    DOCKERFILE_CONTEXT: ./gateway
    BASE_IMAGE: $DOCKER_REGISTRY/$PROJECT_NAME/apigw
  needs: []

# lint apigw nginx config:
#   stage: post lint application
#   image: 
#     name: $DOCKER_REGISTRY/$PROJECT_NAME/apigw:$COMMIT_TAG
#     entrypoint: ["sh"]
#   script:
#     - nginx -t
#   needs: ["build apigw dockerfile"]

# Validate, plan & apply terraform

validate terraform:
  stage: validate terraform
  extends: .terraform_validate
  variables:
    TF_ROOT: $CI_PROJECT_DIR/infra/terraform
  needs: []

plan terraform:
  stage: plan terraform
  variables:
    TF_ROOT: $CI_PROJECT_DIR/infra/terraform
  extends: .terraform_plan
  needs: []
  
apply terraform:
  stage: apply terraform
  extends: .terraform_apply
  script:
    - terraform output -json kube_config | jq -r . > $CI_PROJECT_DIR/kube_config
    - ls -alh $CI_PROJECT_DIR
  environment:
    name: aks-master
  cache:
    paths:
      - $CI_PROJECT_DIR/kube_config
  needs: ["validate terraform", "plan terraform"]

# deploy helm

deploy helm:
  stage: deploy application
  extends: .config_helm
  variables:
    KUBE_CONFIG_FILE: $CI_PROJECT_DIR/kube_config
    INSTALL_INGRESS: "yes"
    HELM_VALUES_TEMPLATE: ./infra/helm-chart/values.yml.j2
    GATEWAY_BASE_IMAGE: $DOCKER_REGISTRY/$PROJECT_NAME/apigw
    GATEWAY_IMAGE_TAG: $COMMIT_TAG
  script:
    - helm dependency update ./infra/helm-chart
    - helm upgrade 
      -f $HELM_VALUES
      --install demo-$CI_COMMIT_REF_NAME ./infra/helm-chart
  environment:
    name: helm-master
  cache:
    paths:
      - $CI_PROJECT_DIR/kube_config
  needs: ["apply terraform", "lint apigw dockerfile", "build apigw dockerfile"]

# install ingress:
#   stage: deploy application
#   extends: .config_helm
#   variables:
#     KUBE_CONFIG_FILE: $CI_PROJECT_DIR/kube_config
#     INGRESS_NAME_PREFIX: 
#   script:
#     - ls
#   cache:
#     paths:
#       - $CI_PROJECT_DIR/kube_config
#   needs: ["apply terraform"]